!   D02PCF Example Program Text
!   Mark 24 Release. NAG Copyright 2012.

    Module d02pcfe_mod

!     D02PCF Example Program Module:
!            Parameters and User-defined Routines

!     .. Use Statements ..
      Use nag_library, Only: nag_wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Real (Kind=nag_wp), Parameter        :: tol1 = 1.0E-3_nag_wp
      Real (Kind=nag_wp), Parameter        :: tol2 = 1.0E-4_nag_wp
      Integer, Parameter                   :: neq = 2, nin = 5, nout = 6,      &
                                              npts = 8
      Integer, Parameter                   :: lenwrk = 32*neq
    Contains

      Subroutine f(t,y,yp)

!       .. Scalar Arguments ..
        Real (Kind=nag_wp), Intent (In)      :: t
!       .. Array Arguments ..
        Real (Kind=nag_wp), Intent (In)      :: y(*)
        Real (Kind=nag_wp), Intent (Out)     :: yp(*)
!       .. Executable Statements ..
        yp(1) = y(2)
        yp(2) = -y(1)
        Return
      End Subroutine f
    End Module d02pcfe_mod

    Program d02pcfe

!     D02PCF Example Main Program

!     .. Use Statements ..
      Use nag_library, Only: d02pcf, d02pvf, d02pyf, nag_wp
      Use d02pcfe_mod, Only: f, lenwrk, neq, nin, nout, npts, tol1, tol2
!     .. Implicit None Statement ..
      Implicit None
!     .. Local Scalars ..
      Real (Kind=nag_wp)                   :: hnext, hstart, tend, tgot, tinc, &
                                              tol, tstart, twant, waste
      Integer                              :: i, ifail, j, method, stpcst,     &
                                              stpsok, totf
      Logical                              :: errass
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable      :: thres(:), work(:), ygot(:),      &
                                              ymax(:), ypgot(:), ystart(:)
!     .. Intrinsic Procedures ..
      Intrinsic                            :: real
!     .. Executable Statements ..
      Write (nout,*) 'D02PCF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) method
      Allocate (thres(neq),work(lenwrk),ygot(neq),ymax(neq),ypgot(neq), &
        ystart(neq))

!     Set initial conditions and input for D02PVF

      Read (nin,*) tstart, tend
      Read (nin,*) ystart(1:neq)
      Read (nin,*) hstart
      Read (nin,*) thres(1:neq)
      Read (nin,*) errass

!     Set control for output

      tinc = (tend-tstart)/real(npts,kind=nag_wp)

loop: Do i = 1, 2
        If (i==1) Then
          tol = tol1
        Else
          tol = tol2
        End If

!       ifail: behaviour on error exit   
!              =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
        ifail = 0
        Call d02pvf(neq,tstart,ystart,tend,tol,thres,method,'Usual Task', &
          errass,hstart,work,lenwrk,ifail)

        Write (nout,99999) tol
        Write (nout,99998)
        Write (nout,99997) tstart, ystart(1:neq)
        twant = tstart
        Do j = 1, npts
          twant = twant + tinc

          ifail = -1
          Call d02pcf(f,twant,tgot,ygot,ypgot,ymax,work,ifail)

          Write (nout,99997) tgot, ygot(1:neq)
        End Do

        ifail = 0
        Call d02pyf(totf,stpcst,waste,stpsok,hnext,ifail)
        Write (nout,99996) totf

      End Do loop

99999 Format (/' Calculation with TOL = ',E8.1)
99998 Format (/'    t         y1        y2'/)
99997 Format (1X,F6.3,2(3X,F7.3))
99996 Format (/' Cost of the integration in evaluations of F is',I6)
    End Program d02pcfe
